require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module Env
      class Lock

        # Attributes of the Lock for lock create operation.
        class LockCreate < UU::OS::REST::DTO

          # Code of the lock.
          # @param [String]
          # @return [String]
          attr_accessor :code

          # Name of the lock.
          # @param [String]
          # @return [String]
          attr_accessor :name

          # Timeout for the lock expiration (in seconds).
          # @param [Numeric]
          # @return [Numeric]
          attr_accessor :lock_timeout

          # Flag if the lock is reentrant.
          # @param [TrueClass, FalseClass]
          # @return [TrueClass, FalseClass]
          attr_accessor :reentrant

          # Wait timeout for which process want to wait for lock creation (in seconds).
          # @param [Numeric]
          # @return [Numeric]
          attr_accessor :wait_timeout

          def code
            attributes[:code]
          end

          def code=(val)
            attributes[:code] = val
          end

          def name
            attributes[:name]
          end

          def name=(val)
            attributes[:name] = val
          end

          def lock_timeout
            attributes[:lockTimeout]
          end

          def lock_timeout=(val)
            if val
              attributes[:lockTimeout] = val.to_i
            else
              attributes[:lockTimeout] = nil
            end
          end

          def reentrant
            attributes[:reentrant]
          end

          def reentrant=(val)
            attributes[:reentrant] = val
          end

          def wait_timeout
            attributes[:waitTimeout]
          end

          def wait_timeout=(val)
            if val
              attributes[:waitTimeout] = val.to_i
            else
              attributes[:waitTimeout] = nil
            end
          end

        end

      end
    end
  end
end
