require 'uu/os/rest/dto'

module UU
  module OS
    module QoS
      # DTO with a QoS attributes for access role. The values means a request limit in a particular period. Special values are 0 (no request is allowed) and -1 (unlimited).
      class AccessRoleGetQoS < UU::OS::REST::DTO

        # Year rate. Maximal number of requests per year.
        #
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :year_rate

        # Month rate. Maximal number of requests per month.
        #
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :month_rate

        # Week rate. Maximal number of requests per week.
        #
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :week_rate

        # Day rate. Maximal number of requests per day.
        #
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :day_rate

        # Hour rate. Maximal number of requests per hour.
        #
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :hour_rate

        # Minute rate. Maximal number of requests per minute.
        #
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :minute_rate
        def year_rate
          attributes[:yearRate]
        end

        def year_rate=(val)
          attributes[:yearRate] = val
        end

        def month_rate
          attributes[:monthRate]
        end

        def month_rate=(val)
          attributes[:monthRate] = val
        end

        def week_rate
          attributes[:weekRate]
        end

        def week_rate=(val)
          attributes[:weekRate] = val
        end

        def day_rate
          attributes[:dayRate]
        end

        def day_rate=(val)
          attributes[:dayRate] = val
        end

        def hour_rate
          attributes[:hourRate]
        end

        def hour_rate=(val)
          attributes[:hourRate] = val
        end

        def minute_rate
          attributes[:minuteRate]
        end

        def minute_rate=(val)
          attributes[:minuteRate] = val
        end

      end
    end
  end
end